/*
 * License: GPL (see COPYING) and CIPL (see COPYING-CIPL).
 *
 *
 * Originally written by Alphex Kaänoken <kaanoken@crew.org.ru>
 * All `core' and AI-like machine I wrote after beer ;-)
 * 
 * (c) Crew IT Research Labs 2004
 */
/*
 * NOTE: This is a part of X Neural Switch, parse text file, find words,
 * create xneur file for language.
 * The first string must be `[xneur-<language>]\n' where language is - 
 * us - US english
 * fi - suomi
 * ru - russian
 * ee - eesti
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "analisys.h"

#define BUF_TSIZE  256
#define MAX_WLEN  8

/*config loading*/
/*We're have the following format
 * LANG: <what the language>
 * ABC: <char in low-case without any chars, in exmaple: ABC: a b c d e f g h i j k l m o ... \n>
 *All chars must be in uncode like ö ä å 
 */
int LoadLangProto(char *flname,void *data)
{
  int lw=0,i=0,ik=0;
  int c=0;
  int ca=0;
  int sect=0; /*what we're must to read*/
  char *buf=(char *)_malloc(BUF_TSIZE*4);
  char *t_ptr=buf;
  FILE *ins=NULL;
  char *awrd=(char *)_malloc(MAX_WLEN);
  char *t_awrd=awrd;
  int ci=0;

  if(!flname)
    return -1;
  else if(!(lw=strlen((const char*)flname)))
    return -1;
  else {
    if((ins=fopen((const char*)flname,"r"))!=NULL){
      buf=memset(buf,'\0',BUF_TSIZE*4);

      while((c=fgetc((FILE*)ins))!=EOF) {
	switch(c){
	case '\n':
	  /*just parse*/
	  if(!sect){
	    fprintf(stderr,"[ERR]: Unrecognized line:\n %s \nExiting...\n",t_ptr);
	    fclose(ins);
	    free(buf);
	    free(awrd);
	    return -1;
	  } else if(sect==1){
	    /*just parse first word - language*/
	    buf=t_ptr;
	    awrd=memset(awrd,'\0',MAX_WLEN);
	    while(*buf++!='\0'){
	      if(*buf==' ')
		break;
	      else
		*awrd++=*buf;
	    }
	    ((ProtoLang *)data)->lang=strdup(t_awrd);
	    awrd=t_awrd;
	  } else if(sect==2){
	    buf=t_ptr;
	    awrd=memset(awrd,'\0',MAX_WLEN);
	    while(*buf++!='\0'){
	      if(*buf==' '){
		awrd=t_awrd;
		if(strlen((const char*)awrd)){
		  ((ProtoLang *)data)->abc=AddSList(((ProtoLang *)data)->abc,(char *)strdup(awrd));
		  awrd=memset(awrd,'\0',MAX_WLEN);
		}
		ci=0;
	      }
	      else{
		*awrd++=*buf;
		++ci;
	      }
	      if(ci>(MAX_WLEN-1)){
		fprintf(stderr,"[ERR]: Section `ABC' has illegal value!\n");
		fclose(ins);
		free(buf);
		free(awrd);
		return -1;
	      }
	    }
	    awrd=t_awrd;
	  } else {
	    fprintf(stderr,"[ERR]: Section has illegal value!\n");
	    fclose(ins); /*free buffers*/
	    free(buf);
	    return -1;
	  }
	  sect=0; /*reset flags, and fill buffer for null-terminated symbol*/
	  ca=0;
	  buf=t_ptr;i=0;
	  buf=memset(buf,'\0',BUF_TSIZE*4);
	  break;
	case ' ':
	  if(!ca){
	    if(!(ik=strncmp((const char*)t_ptr,"LANG:",5)))
	      sect=1;
	    else if(!(ik=strncmp((const char*)t_ptr,"ABC:",4)))
	      sect=2;
	    else {
	      fprintf(stderr,"[ERR]: Unrecognized option:\n %s \nExiting...\n",t_ptr);
	      fclose(ins);
	      free(buf);
	      return -1;
	    }
	    buf=memset(buf,'\0',BUF_TSIZE*4);
	    buf=t_ptr;
	    i=-1;
	  }
	  break;
	default:
	  if(ca<2)
	    *buf++ = (char) c;
	  break;
	}
	++i; /*increase counter*/
	if(i>BUF_TSIZE*4){
	  fprintf(stderr,"[ERR]: Too long line, are you that is a normal file?\nFILE: %s\nExiting ...\n",flname);
	  fclose(ins);
	  free(buf);
	  return -1;
	}
      }

      free(buf);
      free(awrd);
      fclose(ins);
    }
    else
      return -1;
  }
  return 0;
}

/*external collector - text file*/
int LookTextFile(char *flname,void *data)
{
  int lw=0,i=0;
  int c=0;
  char *buf=(char *)_malloc(BUF_TSIZE);
  char *t_ptr=buf;
  FILE *ins=NULL;

  if(flname==NULL)
    return -1;
  else if((lw=strlen(flname))==0)
    return -1;
  else {
    if((ins=fopen((const char*)flname,"r"))!=NULL){
      buf=memset(buf,'\0',BUF_TSIZE);

      while((c=fgetc(ins))!=EOF){
	switch(c){
	case ' ': /*stop reading and goto for the buffer analysis*/
	case '\n':
	  i=1;
	  break; /*it seems to me that we're don't need for scanning some braces etc.*/
	default:
	  if(!i)
	    *buf++ = (char)c;
	  else {
	    /*analysis the buffer*/
	    i=LookTextFileLine(t_ptr,data);
	    buf=memset(buf,'\0',BUF_TSIZE);
	  }
	  break;
	}
      }

      free(buf);
      fclose(ins);
    } else 
      return -1;
  }
  return 0;
}

int LookTextFileLine(char *line,void *data)
{
  return 0;
}

/*external collector - dictionary. format - <word> - <decription of word>, this collector looks only for <word>*/
int LookDictFile(char *flname,void *data)
{
  return 0;
}

int LookDictFileLine(char *flname,void *data)
{
  return 0;
}

/*TODO: external collector - human input*/
/*It work with human input and scans for words and semantic*/
int LookDevInput(void **input,void *data)
{
  return 0;
}

/*khowelege base operations*/
/*linked list operations*/
WList *AddWList(WList *ptr,void *data)
{
  WList *lp=ptr;
  if(ptr!=NULL){
    while(ptr->next!=NULL)
      ptr=ptr->next;

    ptr->next=(WList*) _malloc(sizeof(WList));
    ptr=ptr->next;
    ptr->next=NULL;
    ptr->data=data;
    return lp;
  } else{
    ptr=(WList*) _malloc(sizeof(WList));
    ptr->next=NULL;
    ptr->data=data;
    return ptr;
  }
}

WList *DelWList(WList *ptr,void *data)
{
  WList *prev=NULL;
  WList *curr;
  curr=ptr;

  while(curr!=NULL && curr->data!=data){
    prev=curr;
    curr=curr->next;
  }
  if(curr==NULL)
    return ptr;
  if(curr==ptr)
    ptr=curr->next;
  else
    prev->next=curr->next;
  if(curr->data!=NULL)
    free(curr->data);
  free(curr);
  return ptr;
}

WList *RmWlist(WList *ptr)
{
  if(ptr!=NULL){
    while(ptr!=NULL){
      ptr=DelWList(ptr,ptr->data);
      ptr=ptr->next;
    }
    return NULL;
  } else {
    return NULL;
  }
  return ptr;
}

/*Sliced list operations*/
SList *AddSList(SList *ptr,void *data)
{
}

SList *DelSList(SList *ptr,void *data)
{
}

SList *RmSList(SList *ptr)
{
}

/*binary tree operations*/
void TreeInit(Tree *tree, void (*destroy)(void *data)) 
{
  tree->size = 0;
  tree->destroy = destroy;
  tree->root = NULL;
  
  return;
}

void TreeDestroy(Tree *tree) 
{
  TreeRemLeft(tree, NULL);
  memset(tree, 0, sizeof(Tree));

  return;
}

int TreeInsLeft(Tree *tree,TreeNode *node,const void *data) 
{
  TreeNode *new_node,**position;

  if (node == NULL) {
    if (TREESIZE(tree) > 0)
      return -1;
    position = &tree->root;
  }else {
    if (TREELEFT(node) != NULL)
     return -1;

    position = &node->left;
  }

  new_node=(TreeNode *) _malloc(sizeof(TreeNode));
  new_node->data=(void *)data;
  new_node->left=NULL;
  new_node->right=NULL;
  *position=new_node;
  
  tree->size++;

  return 0;
}

int TreeInsRight(Tree *tree,TreeNode *node,const void *data) 
{
  TreeNode *new_node,**position;

  if(node==NULL) {
    if(TREESIZE(tree)>0)
      return -1;
    position = &tree->root;
  }else {
    if (TREERIGHT(node) != NULL)
      return -1;
    position = &node->right;
  }

  new_node=(TreeNode *) _malloc(sizeof(TreeNode));
  new_node->data=(void *)data;
  new_node->left=NULL;
  new_node->right=NULL;
  *position=new_node;

  tree->size++;

  return 0;
}

void TreeRemLeft(Tree *tree,TreeNode *node) 
{
  TreeNode **position;

  if (TREESIZE(tree) == 0)
    return;
  
  if (node==NULL)
    position = &tree->root;
  else
    position = &node->left;
  
  if(*position != NULL) {
    TreeRemLeft(tree,*position);
    TreeRemRight(tree,*position);
    if (tree->destroy != NULL)
      tree->destroy((*position)->data);
    
    free(*position);
    *position = NULL;
    
    tree->size--;
  }
  
  return;
}

void TreeRemRight(Tree *tree, TreeNode *node) 
{
  TreeNode **position;

  if (TREESIZE(tree) == 0)
    return;

  if(node==NULL)
    position=&tree->root;
  else
    position=&node->right;

  if(*position!=NULL) {
    TreeRemLeft(tree,*position);
    TreeRemRight(tree,*position);
    
    if(tree->destroy!=NULL) 
      tree->destroy((*position)->data);
    
    free(*position);
    *position = NULL;
    
    tree->size--;
  }
  
  return;
}

int TreeMerge(Tree *merge,Tree *left,Tree *right,const void *data) 
{
  TreeInit(merge, left->destroy);

  if(TreeInsLeft(merge,NULL,data)!=0){
    TreeDestroy(merge);
    return -1;
  }

  TREEROOT(merge)->left=TREEROOT(left);
  TREEROOT(merge)->right=TREEROOT(right);

  merge->size=merge->size+TREESIZE(left)+TREESIZE(right);

  left->root = NULL;
  left->size = 0;
  right->root = NULL;
  right->size = 0;
  
  return 0;
}

int AddTreeVoid(Tree *tree,void *data)
{
  TreeNode *prev,*node;
  int direction=0;
  void *rdata; 

  node=tree->root;
  while(TREEISEOB(node)){
    prev=node;
    if(data==(void *)TREEDATA(node))
      return -1;
    else if (data < (void *)TREEDATA(node)){
      node=TREELEFT(node);
      direction=1;
    } else {
      node=TREERIGHT(node);
      direction=2;
    }
  }

  rdata=data;

  switch(direction) {
  case 0:
    return TreeInsLeft(tree,NULL,rdata);
    break;
  case 1:
    return TreeInsLeft(tree,prev,rdata);
    break;
  case 2:
    return TreeInsRight(tree,prev,rdata);
    break;
  default:
    return -1;
    break;
  }

  return -1;
}

/********************************************/
/*Search and remove repeatly words*/
WList *RmRepWList(WList *ptr)
{
}

SList *RmRepSList(SList *ptr)
{
}

/*misc operations (we're working with utf-8)*/

/*see differenses*/
int TwlDiff(char *tl,char *dd)
{
}

/*counting of point for 2l*/
