/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Art Vodolazsky <burivuh@crew.org.ru>
 *
 *  (c) Crew IT Research Labs 2004
 */

#ifndef _ERROR_H
#define _ERROR_H

#include "types.h"

#define STDOUT 0
#define LOG 1

//working with error structures
typedef struct {
	char *filename;
	num linenum;
} eLocation;

typedef struct {
	status eType;
	eLocation eLoc;
	char *eString;
	long eData;
} eReport;

status eManager_manage (eReport * ereport, status eOutput);

//NOTE: working with only %s and %d eData values
status eReport_send (status eType, char *eString, void *eData, char *_FILE, num _LINE);

eReport *eReport_make (status eType, char *eString, void *eData, char *_FILE, num _LINE);

status eReport_free (eReport * ereport);

//look at eReport_send function
#define send_error(eType, eString, eData) eReport_send(eType, eString, eData, __FILE__, __LINE__)

#endif /* _ERROR_H */
