/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Alphex Kaanoken <kaanoken@crew.org.ru>
 *
 *  NOTE: This is frontend for some usually used functions like malloc,
 *  it's purposes to make code good-like without many check and other
 *
 *  (c) Crew IT Research Labs 2004
 *
 */

#include "utils.h"

void _panic(void)
{
  fprintf(stderr,"[ERR]: Critical error.Exit.\n");
  exit(-1);
}

void *_malloc(int bytes)
{
  void *ptr=NULL;
  ptr=malloc(bytes);
  if(ptr==NULL){
    fprintf(stderr,"[ERR]: Cannot allocate %d bytes\n",bytes);
    _panic();
  }
  else
    return ptr;
}

void *_calloc(int block,int bytes)
{
  void *ptr=NULL;
  ptr=calloc(block,bytes);
  if(ptr==NULL){
    fprintf(stderr,"[ERR]: Cannot allocate %d block of %d bytes\n",block,bytes);
    _panic();
  }
  else
    return ptr;
}
